require-kiss
====

Require: Keepin' It Stupid-Simple for both SSJS and Browsers alike.

Great for including (concatonating) in your library so that your example code can be the same on the client as the server.

Installation & Usage
====

**Node.js** / **SSJS**

    npm install require-kiss

Generally good practices:
  * Wrap all of your modules as modules (as you would in the Browser to prevent global namespace leakage).
  * To export modules use `provide` and `module.exports`, not just `exports`
  * JSLint your code!

Create a JavaScript file which includes proper jslint options, scoping, and provide.

    mkjs my-module.js

Create an HTML5 application that includes require-kiss.js

    mkhtml index.html

**Browser**

Concatonate `require-kiss.js` to the top of your module.

Or include it in the page

    <script scr="require-kiss.js"></script>


Example
==== 

`mkjs my-module.js`

For a more complete example look in `example`.

    (function () {
      "use strict";

      require('require-kiss');

      var otherModule = require('other-module');

      function MyModule() {
          // your code here
      }

      module.exports = MyModule
      provide("my-module", module.exports);
    }());

Explanation
----

    "use strict";

this tells the interpreter to use "JavaScript, the good parts"
and to be less forgiving of "JavaScript, the bad parts"

    require('require-kiss');

loads `provide` (shim for CommonJS)
and `global` and `__dirname` (shim for Browser)

    var otherModule = require('other-module');

import a module which has been `provide`d (Browser) or exported (CommonJS)

    function MyModule() {
        // your code here
    }

    module.exports = MyModule

The CommonJS way to export a module

    provide("my-module", module.exports);

shim for the Browser, which cannot understad `module.exports`
