/*jslint browser: true, devel: true, debug: true, es5: true, onevar: true, undef: true, eqeqeq: true, plusplus: true, bitwise: true, regexp: true, newcap: true, immed: true, strict: true */
/*
  var window = {}, exports = {}, module = {}, global = {};
*/
// Implementation of require(), modules, exports, and provide to the browser
(function () {
    "use strict";
    if ('undefined' !== typeof window && 'undefined' !== typeof alert) {
      (function () {
        var global = window;
        function resetModule() {
          global.module = {};
          global.exports = {};
          global.module.exports = exports;
        }
        global._PLUGIN_EXPORTS = global._PLUGIN_EXPORTS || {};
        global.require = function (name) {
          var plugin = global._PLUGIN_EXPORTS[name] || global[name],
            msg = "One of the included scripts requires '" + 
              name + "', which is not loaded. " +
              "\nTry including '<script src=\"" + name + ".js\"></script>'.\n";
          if ('undefined' === typeof plugin) {
            alert(msg);
            throw new Error(msg);
          }
          return plugin;
        };
        global.provide = function (name) {
          global._PLUGIN_EXPORTS[name] = module.exports;
          resetModule();
        };
        resetModule();
      }());
    } else {
      global.provide = function () {};
    }
}());
// A module with no dependency on any other modules
var provide = provide || function () {};
(function () {
  "use strict";

  console.log("SubmoduleA loading");

  function SubmoduleA() {
    console.log("SubmoduleA");
  }

  module.exports = SubmoduleA;

  provide('mymodule/submodule-a');

  console.log("SubmoduleA loaded");
}());
var provide = provide || function () {},     // in CommonJS / Node.js `provide` is a noop
  __dirname = __dirname || '';                // give the browser an empty __dirname to work with
(function () {
  "use strict";

  console.log("SubmoduleB loading");

  // require with the full path (Node.js) or an empty one (Browser)
  var SubmoduleA = require((__dirname ? __dirname + '/' : 'mymodule') + '/submodule-a');

  // Declare the module
  function SubmoduleB() {
    SubmoduleA();
    console.log("SubmoduleB");
  }

  // in the browser this is declared as a global by require-kiss
  module.exports = SubmoduleB;

  // in the Browser `module.exports` will be read in with this name and then cleared
  provide('mymodule/submodule-b');

  console.log("SubmoduleB loaded");
}());
var provide = provide || function () {},    // in CommonJS / Node.js `provide` is a noop
  __dirname = __dirname || '';               // give the browser a `__dirname` to work with
(function (){
  "use strict";

  console.log("MyModule loading");

  var module_name = 'mymodule',
    loadpath = __dirname ? __dirname : module_name;

  // require with the real path (Node.js) or a module-named namespace (Browser)
  module.exports = {
    SubmoduleA: require(loadpath + '/submodule-a'),
    SubmoduleB: require(loadpath + '/submodule-b'),
  };

  // in the Browser `module.exports` will be read in with this name and then cleared
  provide(module_name, module.exports);

  console.log("MyModule (all submodules) loaded");
}());
